<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Extensible Arrays</TITLE>
<link href="suif1_99.html" rel=Next>
<link href="suif1_97.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_97.html">previous</A>, <A HREF="suif1_99.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC98" HREF="suif1_toc.html#TOC98">Extensible Arrays</A></H2>
<P>
<A NAME="IDX689"></A>

</P>
<P>
Arrays are very efficient data structures but they can only be used when
their size is known in advance.  For situations where the number of
elements is not even known at run-time, most programmers resort to using
linked lists.  SUIF provides a compromise.  Extensible arrays provide
almost the same efficiency as arrays without requiring a bound on the
number of elements.  They are not as flexible as linked lists, however,
because it is still not possible to insert new elements in the middle of
an extensible array.

</P>
<P>
<A NAME="IDX690"></A>
<A NAME="IDX691"></A>
Extensible arrays are implemented by the <CODE>x_array</CODE> class in the
files <TT>`xarray.h'</TT> and <TT>`xarray.cc'</TT>.  When an <CODE>x_array</CODE> is
first created, you must specify the number of elements to be allocated
in the first chunk of memory.  If more elements are needed later,
additional chunks of the same size will be allocated automatically.  The
<CODE>ub</CODE> method returns the number of elements that are currently in an
<CODE>x_array</CODE>.

</P>
<P>
<A NAME="IDX692"></A>
The elements of an <CODE>x_array</CODE> cannot be referenced until they are
added to the array.  New elements can only be added at the end of an
array by using the <CODE>extend</CODE> method.  In this way an <CODE>x_array</CODE>
behaves like a linked list.  Elements must be appended (with
<CODE>extend</CODE>) to the end of an array before they can be used.

</P>
<P>
<A NAME="IDX693"></A>
The <CODE>x_array</CODE> class also provides an <CODE>operator[]</CODE> method so
that once an element has been entered in an <CODE>x_array</CODE> it can be
referenced using the standard array reference syntax.  This works
regardless of which chunk of memory contains the element.

</P>
<P>
<A NAME="IDX694"></A>
Each element of an <CODE>x_array</CODE> is a <CODE>void*</CODE> pointer.  You can
cast these pointers to any other type that fits in the same amount of
storage.  A better solution is to use the <CODE>DECLARE_X_ARRAY</CODE> macro
to derive a subclass of <CODE>x_array</CODE> with elements that are pointers
to the correct type.  This macro takes three arguments: the name of the
derived class, the type to which the elements should point, and the
default chunk size.  As with the macros for creating new list classes,
this is just a cheap substitute for templates.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_97.html">previous</A>, <A HREF="suif1_99.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
